%Reduced from a script of Rob Campbell (https://nl.mathworks.com/matlabcentral/fileexchange/26508-notboxplot)
function notBoxPlot4(y,ppcondition,roundingdigits)

x=1:size(y,2);
jitter=0.3;
hold on
for ii=1:size(y,2)
    myPlotter(x(ii),y(:,ii),ppcondition(:,ii))
end
hold off
    function myPlotter(X,Y,ppcondition)
        jitScale=jitter*0.75;
        for k=1:length(X)
            thisY=Y(:,k);
            ppY=ppcondition(:,k);
            ppY=ppY(~isnan(thisY));
            thisY=thisY(~isnan(thisY));
            thisX=repmat(X(k),1,length(thisY));
            ptch=patch([X(k)-jitScale, X(k)+jitScale, X(k)+jitScale, X(k)-jitScale],[prctile(Y(:,k),25),prctile(Y(:,k),25),prctile(Y(:,k),75),prctile(Y(:,k),75)], 0);
            set(ptch,'edgecolor',[0.8 0.56 0.56],'facecolor',[1 0.7 0.7])
            plot([X(k)-jitScale,X(k)+jitScale],[median(thisY),median(thisY)],'-r','linewidth',2);
            thisX=violaPoints(thisX,thisY);
            plot(thisX(ppY==1),thisY(ppY==1),'o','color',[0 0 0],'markerfacecolor',[1 1 1],'markersize',10,'linewidth',2);hold on
            plot(thisX(ppY==2),thisY(ppY==2),'o','color',[0 0 0],'markerfacecolor',[0 0 0],'markersize',10,'linewidth',2);
            
                        if roundingdigits==0
                text(X(k)+0.25,nanmean(Y),sprintf('%0.0f',nanmean(Y)))
            elseif roundingdigits==1
                if nanmean(Y)==0 && ii<=2
                    text(X(k)+0.25,2.5,sprintf('%0.1f',nanmean(Y)))
                elseif nanmean(Y)==0 && ii==7
                    text(X(k)+0.25,6.25,sprintf('%0.1f',nanmean(Y)))
                else
                    text(X(k)+0.25,nanmean(Y),sprintf('%0.1f',nanmean(Y)))
                end
            elseif roundingdigits==2
                text(X(k)+0.25,nanmean(Y),sprintf('%0.2f',nanmean(Y)))
            end

        end
        function X=violaPoints(X,Y)
            [counts,~,bins]=histcounts(Y,20);
            inds=find(counts~=0);
            counts=counts(inds);
            Xr=X;
            for jj=1:length(inds)
                tWidth=jitter*(1-exp(-0.1*(counts(jj)-1)));
                xpoints=linspace(-tWidth*0.8,tWidth*0.8,counts(jj));
                Xr(bins==inds(jj))=xpoints;
            end
            X=X+Xr;
        end
    end
end